__rcs_id__='$Endicor: CalendarTag.py,v 1.13 1999/04/25 22:09:31 tsarna Exp tsarna $'
__version__='$Revision: 1.13 $'[11:-2]

from DocumentTemplate.DT_Util import *
from DocumentTemplate.DT_String import String
from DateTime.DateTime import DateTime
#from socket import gethostname
#import string


start = """
<table border=0 bgcolor="%(bgcolor)s" cellspacing=0 cellpadding=0>
 <tr>
  <td align="left" valign="center" bgcolor="%(leftbgcolor)s">
   <font color="%(leftfgcolor)s">
    %(left)s
   </font>
  </td>

  <td align="center" valign="top" bgcolor="%(middlebgcolor)s">
%(middle)s
  </td>

  <td align="right" valign="top" bgcolor="%(rightbgcolor)s">
%(right)s
  </td>
 </tr>
 <tr>
  <td bgcolor="%(bordercolor)s" align="center" valign="center" colspan=3>
   <table border=0 width="100%%" cellspacing="%(spacing)s" cellpadding="%(padding)s">
    <tr>
"""

end = """
    </tr>
   </table>
  </td>
 </tr>
</table>
"""

middle = """
   <table border=0 cellspacing=0 cellpadding=0><tr>
    <td>&nbsp;</td>
    <td><a href="%(url_)s?date-%(name_)s=%(date_)s&mode-%(name_)s=day"><img border=0 src="%(ipath_)s%(day_img_)s" alt="Day"></a></td>
    <td><a href="%(url_)s?date-%(name_)s=%(date_)s&mode-%(name_)s=week"><img border=0 src="%(ipath_)s%(week_img_)s" alt="Week"></a></td>
    <td><a href="%(url_)s?date-%(name_)s=%(date_)s&mode-%(name_)s=month"><img border=0 src="%(ipath_)s%(month_img_)s" alt="Month"></a></td>
   </tr></table>
"""

right = """
   <table border=0 cellspacing=0 cellpadding=0><tr>
    <td>&nbsp;</td>
    <td><a href="%(prev_url_)s"><img border=0 alt="%(prev_alt_)s" src="%(ipath_)slarrow"></a></td>
    <td>%(rightmiddle)s</td>
    <td><a href="%(next_url_)s"><img border=0 alt="%(next_alt_)s" src="%(ipath_)srarrow"></a></td>
   </tr></table>
"""

modes = ('day', 'week', 'month')

days = ('sun', 'mon', 'tutr', 'wed', 'tutr', 'fri', 'sat')
daypat = '<td><a href="%(dow_url_)s"><img border=0 src="%(ipath_)s%(dayimg_)s%(dow_)s"></a></td>'


def datestr(date):
    return '%d-%d-%d' % (date.year(), date.month(), date.day())


class CalendarTag:
    """
    Calendar tag.
    
    See README.txt for usage, author, copyright, and license.
    """

    name = 'calendar'
    blockContinuations = ()

    def __init__(self, blocks):
        tname, args, section = blocks[0]
        self.section = section.blocks
        self.args = parse_params(args, name='', bgcolor='', mode='', date='')

        self.myname = self.getarg_('name', 'calendar')
        self.bgcolor = self.getarg_('bgcolor', 'ffffff')
        self.mode = self.getarg_('mode', 'month')
        if self.mode not in modes:
            self.mode = 'month'
        self.date = self.getarg_('date', None)

    def getarg_(self, name, defval):
        if self.args.has_key(name):
            return self.args[name]
        else:
            return defval

    def render(self, md):
        if md.has_key('date-' + self.myname):
            date = DateTime(md['date-' + self.myname])
        else:
            if self.date:
                d = Eval(self.date, expr_globals)
                d = d.eval(md)
                if type(d) in (type(0), type('')):
                    date = DateTime(d)
                else:
                    date = DateTime(str(d))
            else:
                date = DateTime()

        date = date.earliestTime()
        
        mode = self.mode
        if md.has_key('mode-' + self.myname):
            mode = md['mode-' + self.myname]
        if mode in modes:
            self.mode = mode

        self.vals_ = v = {}

        v['name_'] = self.myname
        v['date_'] = datestr(date)
        v['date'] = date
        v['mode'] = self.mode

        v['spacing'] = '2'
        v['padding'] = '4'
        v['bordercolor'] = '000000'

        v['bgcolor'] = v['leftfgcolor'] = v['middlebgcolor'] = \
            v['rightbgcolor'] = v['daybgcolor'] = self.bgcolor
        v['leftbgcolor'] = '000000'

        v['ipath_'] = md['BASE1'] + '/misc_/Calendar/'
        v['url_'] = md['URL']

        v['day_img_'] = 'day'
        v['week_img_'] = 'week'
        v['month_img_'] = 'month'

        v['rightmiddle'] = '&nbsp;'

        v['prev_alt_'] = 'Previous Week'
        v['prev_url_'] = self.linkDate_(date - 7, mode)

        v['next_alt_'] = 'Next Week'
        v['next_url_'] = self.linkDate_(date + 7, mode)

        v['daynames'] = 'SMTWTFS'

        if self.mode == 'day':
            left = '%s %d, %d' % (date.aMonth(), date.day(), date.year())
            v['day_img_'] = 'sday'
            v['daynames'] = None

            rmid = ''
            for d in range(0, 7):
                if date.dow() == d:
                    v['dayimg_'] = 's'
                else:
                    v['dayimg_'] = ''

                v['dow_'] = days[d]

                v['dow_date_'] = datestr(date - (date.dow() - d))
                v['dow_url_'] = "%(url_)s?date-%(name_)s=%(dow_date_)s&mode-%(name_)s=%(mode)s" % v

                rmid = rmid + daypat % v

            v['rightmiddle'] = rmid
        elif self.mode == 'week':
            sdow = (date - date.dow()).earliestTime()
            edow = (sdow + 6).earliestTime()

            left = '%s %d' % (edow.aMonth(), edow.year())
            if sdow.aMonth() != edow.aMonth():
                left = ' - ' + left
                if sdow.year() != edow.year():
                    left = (' %d' % sdow.year()) + left
                left = sdow.aMonth() + left

            v['week_img_'] = 'sweek'
            v['rightmiddle'] = '&nbsp;Week %d&nbsp;' % (date.dayOfYear() / 7 + 1)
        else:
            left = '%s %d' % (date.Month(), date.year())
            v['month_img_'] = 'smonth'
            v['prev_alt_'] = 'Previous Month'
            v['next_alt_'] = 'Next Month'

            d = (date - date.day()).earliestTime()
            d = d - (d.day() - 1)
            v['prev_url_'] = self.linkDate_(d, mode)

            d = (date - (date.day() - 40)).earliestTime()
            d = d - (d.day() - 1)
            v['next_url_'] = self.linkDate_(d, mode)

        v['middle'] = middle % v
        v['left'] = '&nbsp;&nbsp;' + left + '&nbsp;&nbsp;'


        s = ""

        if self.mode == 'day':
            s = self.render_day_(md, date, 1)
        elif self.mode == 'week':
            d = date - date.dow()
            for i in range(0, 7):
                s = s + self.render_day_(md, d + i, i == 0)
        elif self.mode == 'month':
            bd = date - (date.day() - 1)
            if bd.dow():
                s = s + '<td colspan=%d bgcolor="%s">&nbsp;</td>' % \
                    (bd.dow(), self.bgcolor)
            newrow = 0
            for i in range(0, 40):
                d = bd + i
                if d.month() != bd.month():
                    if d.dow():
                        s = s + '<td colspan=%d bgcolor="%s">&nbsp;</td>' % \
                            (7 - d.dow(), self.bgcolor)
                    break
                else:
                    if newrow:
                        s = s + '</tr><tr>'
                        newrow = 0
                    s = s + self.render_day_(md, d, i == 0)
                    if d.dow() == 6:
                        newrow = 1

        if v['daynames'] and (mode != 'day'):
            x = ''
            c = v['daybgcolor']

            for d in v['daynames']:
                x = x + '<th bgcolor="%s">%s</th>' % (c, d)

            s = x + '</tr><tr>' + s

        if not v.has_key('right'):
            v['right'] = right
            
        v['right'] = v['right'] % v

        return (start % v) + s + end

    __call__ = render

    def render_day_(self, md, date, firstday):
        ns = namespace(self,
            date = date,
            mode = self.mode,
            firstday = firstday,
            setCalendar = self.setCalendar_,
            getCalendar = self.getCalendar_,
            linkDate = self.linkDate_
        )[0]

        md._push(InstanceDict(ns, md))

        v = self.vals_
        v['cellbgcolor'] = self.bgcolor
        v['align'] = None
        v['valign'] = None

        try:
            s = render_blocks(self.section, md)
        finally:
            md._pop(1)
            pass

        pre = '<td bgcolor="%s"' % v['cellbgcolor']
        x = v['align']
        if x is not None:
            pre = pre + ' align="%s"' % x
        x = v['valign']
        if x is not None:
            pre = pre + ' valign="%s"' % x

        return pre + '>' + s + '</td>\n'


    def linkDate_(self, date, mode = 'day'):
        if mode not in modes:
            mode = 'day'

        v = self.vals_
        s = '%(url_)s?date-%(name_)s=' % v
        return s + datestr(date) + ('&mode-%(name_)s=' % v) + mode

        
    def setCalendar_(self, name, val):
        self.vals_[name] = val


    def getCalendar_(self, name, defval = None):
        if self.vals_.has_key(name):
            return self.vals_[name]
        else:
            return defval
	
	

# Install the calendar tag globally

String.commands['calendar'] = CalendarTag
